theory Matching_Impl
imports
  Map_To_Mapping
  Matching
begin

lift_definition
  match_term_list_code ::
    "(('f, 'v) term \<times> ('f, 'w) term) list \<Rightarrow>
    ('v, ('f, 'w) term) mapping \<Rightarrow>
    ('v, ('f, 'w) term) mapping option"
is match_term_list .

lemmas [code] =  match_term_list.simps [transferred_mapping]

lemmas match_term_list_code_simps [simp]
  = match_term_list.simps [transferred_mapping]

lemma Mapping_match_term_list:
  "Option.map Mapping (match_term_list P \<sigma>) =
    (match_term_list_code P (Mapping \<sigma>))"
  by (induct P \<sigma> rule: match_term_list.induct)
     (simp_all add: fun_upd_apply [abs_def] Mapping.lookup.abs_eq Mapping.update.abs_eq
               split: option.splits)

lemma option_map_id [simp]:
  "Option.map (\<lambda>x. x) x = x"
  by (cases x) simp_all

lemma match_term_list_conv:
  "match_term_list P \<sigma> =
    Option.map Mapping.lookup (match_term_list_code P (Mapping \<sigma>))"
proof -
  from Mapping_match_term_list [of P \<sigma>]
    have "Option.map Mapping.rep (Option.map Mapping (match_term_list P \<sigma>)) =
      Option.map Mapping.rep (match_term_list_code P (Mapping \<sigma>))" by simp
  then show ?thesis
    unfolding Mapping.lookup.rep_eq [abs_def]
    by (simp add: option_map_comp o_def Mapping_inverse)
qed

text {*More efficient code for @{const match_list}.*}
lemma [code]:
  "match_list P =
    Option.map (subst_of_map undefined \<circ> Mapping.lookup) (match_term_list_code P Mapping.empty)"
  by (simp add: match_list_def match_term_list_conv option_map_comp Mapping.empty.abs_eq)

end

